#version 130

uniform mat4 u_ProjectionMatrix = mat4(1.0);
uniform mat4 u_ViewMatrix = mat4(1.0);

//uniform ivec3 u_TileOffset = ivec3(0, 0, 0);

attribute vec3  a_Position;
attribute vec3  a_Normal;
attribute ivec3 a_TileOffset;
attribute ivec3 a_Color;

varying vec4 v_Position; // in camera coordinates
varying vec4 v_Normal;
varying vec4 v_Color;

const float TILE_SIZE = 1.0;
const vec3 halfOffset = vec3(0.0, 0.0, 0.0);

void main()
{
    v_Position = u_ProjectionMatrix * u_ViewMatrix * vec4((a_Position + halfOffset + vec3(a_TileOffset)) * TILE_SIZE, 1.0);
    gl_Position = v_Position;

    v_Normal = normalize(u_ProjectionMatrix * u_ViewMatrix * vec4(a_Normal, 0.0));
    v_Color = vec4(vec3(a_Color), 255.0) / 255.0;
}